﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Infragistics.Web.Mvc;
using igHierarchicalGrid_List_GridModel.Models;

namespace igHierarchicalGrid_List_GridModel.Controllers
{
    public class HomeController : Controller
    {
        static DataUtil data = new DataUtil();

        public ActionResult Index()
        {
            GridModel grid = GridLoadOnDemandModel();
            grid.ID = "grid";
            grid.LoadOnDemand = true;
            grid.DataSourceUrl = Url.Action("BindParent");
            grid.ColumnLayouts[0].DataSourceUrl = Url.Action("BindChild");
            return View(grid);
        }

        private GridModel GridLoadOnDemandModel()
        {
            // Define the Categories layout
            GridModel grid = new GridModel();
            grid.AutoGenerateLayouts = false;
            grid.AutoGenerateColumns = false;
            grid.PrimaryKey = "CategoryID";
            grid.Width = "100%";
            grid.Columns.Add(new GridColumn() { HeaderText = "CategoryID", Key = "CategoryID", DataType = "number", Width = "0%", Hidden = true });
            grid.Columns.Add(new GridColumn() { HeaderText = "CategoryName", Key = "CategoryName", DataType = "string", Width = "40%" });
            grid.Columns.Add(new GridColumn() { HeaderText = "Description", Key = "Description", DataType = "string", Width = "60%" });

            // Define the Products layout
            GridColumnLayoutModel layout = new GridColumnLayoutModel();
            layout.Key = "Products";
            layout.ForeignKey = "CategoryID";
            layout.PrimaryKey = "ProductID";
            layout.AutoGenerateColumns = false;
            layout.Columns.Add(new GridColumn() { HeaderText = "ProductID", Key = "ProductID", DataType = "number", Width = "0%", Hidden = true });
            layout.Columns.Add(new GridColumn() { HeaderText = "CategoryID", Key = "CategoryID", DataType = "number", Width = "0%", Hidden = true });
            layout.Columns.Add(new GridColumn() { HeaderText = "ProductName", Key = "ProductName", DataType = "string", Width = "40%" });
            layout.Columns.Add(new GridColumn() { HeaderText = "UnitPrice", Key = "UnitPrice", DataType = "number", Width = "30%" });
            layout.Columns.Add(new GridColumn() { HeaderText = "UnitsInStock", Key = "UnitsInStock", DataType = "number", Width = "30%" });

            layout.Width = "100%";
            grid.ColumnLayouts.Add(layout);

            GridPaging paging = new GridPaging();
            paging.Type = OpType.Remote;
            paging.Inherit = true;
            paging.PageSize = 5;
            grid.Features.Add(paging);

            //GridSorting sorting = new GridSorting();
            //sorting.Type = OpType.Remote;
            //sorting.Inherit = true;
            //grid.Features.Add(sorting);

            //GridFiltering filtering = new GridFiltering();
            //filtering.Type = OpType.Remote;
            //filtering.Inherit = true;
            //grid.Features.Add(filtering);

            return grid;
        }

        public JsonResult BindParent()
        {
            GridModel model = GridLoadOnDemandModel();
            model.DataSource = data.Categories.AsQueryable();
            return model.GetData();
        }

        public JsonResult BindChild(string path, string layout)
        {
            GridModel model = GridLoadOnDemandModel();
            model.DataSource = data.Products.AsQueryable();
            return model.GetData(path, layout);
        }
    }
}